<?php

require_once $dPconfig['root_dir'] . '/modules/ticketsmith/config.inc.php';
require_once $AppUI->getSystemClass( 'query');

$temp_dir = $dPconfig['root_dir']."/files/temp";
$base_url  = $dPconfig['base_url'];
require( $AppUI->getLibraryClass( 'fpdf/korean' ) );

$type = dPgetParam($_GET, 'type', '');
$column = dPgetParam($_GET, 'column', 'timestamp');
$direction = dPgetParam($_GET, 'direction', 'DESC');
$q =& new DBQuery;
$q->addQuery(array(
	'ticket',
	'author',
	'subject',
	'timestamp',
	'type',
	'assignment',
	'contact_first_name',
	'contact_last_name',
	'activity',
	'priority'
));
$q->addTable('tickets', 'a');
$q->leftJoin('users', 'b', 'a.assignment = b.user_id');
$q->leftJoin('contacts', 'c', 'b.user_id = c.contact_id');
if ($type == 'My') {
	$q->addWhere("type = 'Open'");
	$q->addWhere("(assignment = '$AppUI->user_id' OR assignment = '0')");
} else if ($type != 'All') {
	$q->addWhere("type = '$type'");
}
$q->addWhere("parent = '0'");
$q->addOrder(urlencode($column) . " " . $direction);

$ticketlist = $q->loadHashList('ticket');
if ($err = db_error()) {
	$AppUI->setMsg($err, UI_MSG_ERR);
	$AppUI->redirect();
}

$df = $AppUI->getPref('SHDATEFORMAT');

// adding by young
$pdf=new PDF_Korean('landscape', 'mm', 'A4');
$pdf->AddUHCFont();
$pdf->Open();
$pdf->AddPage();
$pdf->SetFont('UHC','',9);

$pdf->SetMargins( 20, 10 );
//$pdf->SetLeftMargin( 1.5 );
//$pdf->SetRightMargin( 1.5 );

//$pdf->ezSetCmMargins( 1, 2, 1.5, 1.5 );
//$pdf->ezText( dPgetConfig( 'company_name' ), 12 );

$pdf->SetFont('','',12);
//$pdf->SetAuthor( dPgetConfig( 'company_name' ) );
$pdf->Write(12, dPgetConfig( 'company_name' ) );

$date = new CDate();
$pdf->SetFont('','',8);
$pdf->Write(8 , "\n" . $date->format( $df) );

$next_week = new CDate($date);
$next_week->addSpan(new Date_Span(array(7,0,0,0)));

$pdf->SetFont('','',12);
$pdf->Write(12, "\n" . $AppUI->_("$type Ticket Report") );
$pdf->Write(15, "$pname" );
$pdf->Write(12, "\n" );

$pdf->SetFont('','',9);

$title = "$type Tickets";
$options = array(
	'showLines' => 2,
	'showHeadings' => 1,
	'fontSize' => 9,
	'rowGap' => 4,
	'colGap' => 5,
	'xPos' => 50,
	'xOrientation' => 'right',
	'width'=>'750',
	'shaded'=> 0,
	'cols'=>array(
	 	0=>array('justification'=>'center','width'=>70),
		1=>array('justification'=>'center','width'=>70),
		2=>array('justification'=>'center','width'=>45),
		3=>array('justification'=>'center','width'=>15),
		4=>array('justification'=>'center','width'=>15),
		5=>array('justification'=>'center','width'=>15),
		6=>array('justification'=>'center','width'=>15),
		)
);

//$pdf->Write(12, "op[ " . $options['cols'][3][width] . " ]tions" );

$pdfdata = array();
$columns = array(
	ch_enc( $AppUI->_('Author') ) ,
	ch_enc( $AppUI->_('Subject') ) ,
	ch_enc( $AppUI->_('Date') ) ,
	ch_enc( $AppUI->_('Followup') ) ,
	ch_enc( $AppUI->_('Status') ) ,
	ch_enc( $AppUI->_('Priority') ) ,
	ch_enc( $AppUI->_('Owner') ) ,
);

$columns2 = array(
	'<b>' . ch_enc( $AppUI->_('Author') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Subject') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Date') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Followup') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Status') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Priority') ) . '</b>',
	'<b>' . ch_enc( $AppUI->_('Owner') ) . '</b>',
);

foreach ($ticketlist as $ticket) {
	$row =& $pdfdata[];
	$row[] = ch_enc( $ticket['author'] );
	$row[] = ch_enc( $ticket['subject'] );
	$row[] = ch_enc( date($CONFIG['date_format'], $ticket['timestamp']) );
	if ($ticket['activity'])
		ch_enc( $row[] = date($CONFIG['date_format'], $ticket['activity']) );
	else
		$row[] = '-';
	$row[] = ch_enc( $ticket['type'] );
	$row[] = ch_enc( $CONFIG['priority_names'][$ticket['priority']] );
	$row[] = ch_enc( $ticket['contact_firt_name'] . ' ' . $ticket['contact_last_name'] );
}

$pdf->Write(15 , $title . "\n" );
//$pdf->SetTitle( $title );

//$pdf->ezTable( $pdfdata, $columns, $title, $options );
$pdf->BasicTable($columns, $pdfdata, $options);
//$pdf->ImprovedTable($columns ,$pdfdata);
//$pdf->FancyTable($columns ,$pdfdata);

//$pdf->WriteHTML( '<b>' . ch_enc( $AppUI->_('Author') ) . '</b>' );

//$pdf->ezStream();
$pdf->Output();

?>
